unit Unit1;

//Programme par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
OpenDialog1.Title:='Choisir le fichier  copier'; //Change le titre de la boite de dialogue
if OpenDialog1.Execute then Edit1.Text:=OpenDialog1.FileName; //Recupre le chemin du fichier dans Edit1
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
SaveDialog1.Title:='Choisir le fichier de destination';
if SaveDialog1.Execute then Edit2.Text:=SaveDialog1.FileName; //Recupre le chemin du fichier dans Edit2
end;

procedure TForm1.Button3Click(Sender: TObject);
var Source,Destination :File;
NumRead, NumWritten :Integer;
Buf :array[1..2048] of Char;
begin
AssignFile(Source,Edit1.Text); //Associe la variable Source au fichier (Edit1.Text)
Reset(Source,1); //Ouvre le fichier sans le modifier avec une taille d'enregistrement de 1 octet
AssignFile(Destination,Edit2.Text); //Associe la variable Destination au fichier (Edit2.Text)
ReWrite(Destination,1); //Cre puis ouvre un nouveau fichier (Destination) avec une taille d'enregistrement de 1 octet
repeat //Repeter...
BlockRead(Source, Buf, SizeOf(Buf), NumRead); //Lit un ou plusieurs enregistrements d'un fichier ouvert et les place dans une variable
BlockWrite(Destination, Buf, NumRead, NumWritten); //Ecrit un ou plusieurs enregistrements d'une variable mmoire dans un fichier ouvert
until //...Jusqu'
(NumRead = 0) or (NumWritten <> NumRead); //ce que NumRead=0 ou que NumWritten soit diffrent de NumRead
CloseFile(Source); //Ferme l'association entre la variable Source et le fichier (Edit1.Text)
CloseFile(Destination); //Ferme l'association entre la variable Destination et le fichier (Edit2.Text)
ShowMessage('La copie a t effectu'); //Message indiquant que la copie est termin
end;

end.
